﻿import flash.display.DisplayObject;
import flash.display.InteractiveObject;

/**
 * ...
 * @author k0t0vich
 */
class flash.display.DisplayObjectContainer extends InteractiveObject
{

	
	public function DisplayObjectContainer($parent,linkageName) 
	{
		super($parent, linkageName);
		childrenList = new Array();
	}
	/// Adds a child object to this DisplayObjectContainer instance.
		//public var childrenList:Object;
		public var childrenList:Array;
	

		
		private function addToChildrenList(child:DisplayObject):Void
		{
			childrenList.push(child);
			child.index = numChildren-1;
		}
		
		private function removeFromChildrenList(child:DisplayObject):Void
		{
			//delete childrenList[child.instanceId];
			childrenList.splice(child.index, 1);
			var len:Number = numChildren;
			// уменьшаем индексы у последующих
			for (var i:Number = child.index; i < len; i++) 
			{
				childrenList[i].index--;
			}
		}
		
		/**
		 * Вставить внутрь списка
		 * @param	child
		 * @param	$index
		 */
		private function addAtChildrenList(child:DisplayObject,$index:Number):Void
		{
			trace("DisplayObjectContainer.addAtChildrenList > child : " + child + ", $index : " + $index);
			childrenList.splice($index, 0, child);
			child.index = $index
			// увеличиваем индексы у тех кто свыше
			var len:Number = numChildren;
			for (var i:Number = child.index+1; i < len; i++) 
			{
				childrenList[i].index++;
			}
			
		}
		
		/**
		 * Упорядочиваем глубины по индексам
		 */
		private function setChildrenDepths():Void
		{
			var len:Number = numChildren;
			// смотрим минимальную глубину, возможно равна 0.
			var minDepth:Number = getMinimalDepthFromChildList();
			for (var i:Number = 0; i <len ; i++) 
			{
				// ужасная конструкция: сменяем глубину на minDepth + i
				childrenList[i].mc.swapDepths(this.mc.getInstanceAtDepth(minDepth + i));
				trace("childrenList[i].mc : " + childrenList[i].mc);
			}
			
		}
		
		/**
		 * 
		 * @return
		 */
		private function getMinimalDepthFromChildList():Number
		{
			
			var minDepth:Number = childrenList[0].mc.getDepth();
			if (minDepth == 0) return 0;
			
			var len:Number = numChildren;
			for (var i:Number = 0; i <len ; i++) 
			{
				var depth:Number = childrenList[i].mc.getDepth() ;
				if (depth< minDepth)
				minDepth = depth; 
			}
				trace("getMinimalDepthFromChildList : " + minDepth); // по идее всегда 0
			return minDepth;
		}
		
		
		
		////////////////////////////AS3 методы ////////////////////////////////////////
		public function addChild (child:DisplayObject) : DisplayObject
		{
			// TODO: тут в AS3 может произойти смена родителя,или смена индекса наверх, но мы пока ничего не делаем
			if (!child.addedToStage)
			{
				child.addToStage();
				addToChildrenList(child);
				setChildrenDepths();
			}
			else
			{
				//сменяем индекс наверх
				removeFromChildrenList(child);
				addToChildrenList(child);
				setChildrenDepths();
			}
			return child;
		}

		/// Returns the number of children of this object.
		public function get numChildren () : Number
		{
			return childrenList.length;
		}
		
		/// Adds a child object to this DisplayObjectContainer instance.
		public function addChildAt (child:DisplayObject,  $index:Number) : DisplayObject
		{
			if (!child.addedToStage)
			{
				child.addToStage();
				addAtChildrenList(child,$index);
				setChildrenDepths();
			}
			else
			{
				//сменяем индекс наверх
				removeFromChildrenList(child);
				addAtChildrenList(child,$index);
				setChildrenDepths();
			}	
			return child;
		}
		

		/// Returns the child display object instance that exists at the specified index.
		public function getChildAt ($index:Number) : DisplayObject
		{
			if ($index > numChildren - 1) {
				throw(new Error("Illegal index"));
				return null;
			}
			else {
			return childrenList[$index];
			}
		}
		
		/// Returns the child display object that exists with the specified name.
		public function getChildByName (name:String) 
		{
			//Возвращает положенный в таймлайн мувика объект
			return mc[name];
		}

		/// Returns the index number of a child DisplayObject instance.
		public function getChildIndex (child:DisplayObject) : Number
		{
			return child.index;
		}
		
		/// Removes a child display object from the DisplayObjectContainer instance.
		public function removeChild (child:DisplayObject) : DisplayObject
		{
			removeFromChildrenList(child);
			child.index = undefined;
			child.removeFromStage();
			return child;
		}

		/// Removes a child display object, at the specified index position, from the DisplayObjectContainer instance.
		public function removeChildAt ($index:Number) : DisplayObject
		{
			var child:DisplayObject = getChildAt($index);
			removeChild(child);
			return child;
		}

		/// Changes the index number of an existing child.
		public function setChildIndex (child:DisplayObject, $index:Number) : Void
		{
				swapChildren(child, getChildAt($index));			
		}

		/// Swaps the z-order (front-to-back order) of the two specified child objects.
		public function swapChildren (child1:DisplayObject, child2:DisplayObject) : Void
		{
			var tmpIndex:Number = child1.index;
			// смена индексов
			child1.index = child2.index;
			child2.index = tmpIndex;
			// смена в массиве
			childrenList[child1.index] = child1;
			childrenList[child2.index] = child2;
			setChildrenDepths();
		}
		
		
	/*
			/// Determines whether or not the children of the object are mouse enabled.
		public function get mouseChildren () : Boolean;
		public function set mouseChildren (enable:Boolean) : Void;

		/// Determines whether the children of the object are tab enabled.
		public function get tabChildren () : Boolean;
		public function set tabChildren (enable:Boolean) : Void;

		/// Returns a TextSnapshot object for this DisplayObjectContainer instance.
		public function get textSnapshot () : TextSnapshot;

		


		/// Indicates whether the security restrictions would cause any display objects to be omitted from the list returned by calling the DisplayObjectContainer.getObjectsUnderPoint() method with the specified point point.
		public function areInaccessibleObjectsUnderPoint (point:Point) : Boolean;

		/// Determines whether the specified display object is a child of the DisplayObjectContainer instance or the instance itself.
		public function contains (child:DisplayObject) : Boolean;

		



		/// Returns an array of objects that lie under the specified point and are children (or grandchildren, and so on) of this DisplayObjectContainer instance.
		public function getObjectsUnderPoint (point:Point) : Array;



		/// Swaps the z-order (front-to-back order) of the child objects at the two specified index positions in the child list.
		public function swapChildrenAt (index1:Number, index2:Number) : Void;*/
	
}